/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 5);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

__webpack_require__(3);

var _component = __webpack_require__(1);

var _component2 = _interopRequireDefault(_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var VERSION_INFO = { version: "2.1.1", build: 1527869743139 };

//CARTOGRAM TOOL
var Cartogram = Vizabi.Tool.extend("Cartogram", {

  /**
   * Initialized the tool
   * @param {Object} placeholder Placeholder element for the tool
   * @param {Object} external_model Model as given by the external page
   */
  init: function init(placeholder, external_model) {

    this.name = "cartogram";

    //specifying components
    this.components = [{
      component: _component2.default,
      placeholder: ".vzb-tool-viz",
      model: ["state.time", "state.entities", "state.marker", "locale", "ui"] //pass models to component
    }, {
      component: Vizabi.Component.get("timeslider"),
      placeholder: ".vzb-tool-timeslider",
      model: ["state.time", "state.marker", "ui"]
    }, {
      component: Vizabi.Component.get("dialogs"),
      placeholder: ".vzb-tool-dialogs",
      model: ["state", "ui", "locale"]
    }, {
      component: Vizabi.Component.get("buttonlist"),
      placeholder: ".vzb-tool-buttonlist",
      model: ["state", "ui", "locale"]
    }, {
      component: Vizabi.Component.get("treemenu"),
      placeholder: ".vzb-tool-treemenu",
      model: ["state.marker", "state.time", "locale", "ui"]
    }, {
      component: Vizabi.Component.get("datawarning"),
      placeholder: ".vzb-tool-datawarning",
      model: ["locale"]
    }, {
      component: Vizabi.Component.get("datanotes"),
      placeholder: ".vzb-tool-datanotes",
      model: ["state.marker", "locale"]
    }];

    //constructor is the same as any tool
    this._super(placeholder, external_model);
  },


  default_model: {
    state: {},
    ui: {
      chart: {
        labels: {
          dragging: true
        },
        lockNonSelected: 0,
        lockActive: 0,
        sizeSelectorActive: 0
      },
      datawarning: {
        doubtDomain: [],
        doubtRange: []
      },
      presentation: false
    }
  },

  versionInfo: VERSION_INFO
});

exports.default = Cartogram;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

__webpack_require__(2);

var _Vizabi = Vizabi,
    globals = _Vizabi._globals,
    utils = _Vizabi.utils,
    _Vizabi$helpers = _Vizabi.helpers,
    Labels = _Vizabi$helpers.labels,
    d3GeoProjection = _Vizabi$helpers["d3.geoProjection"],
    topojson = _Vizabi$helpers.topojson,
    DynamicBackground = _Vizabi$helpers["d3.dynamicBackground"],
    _Vizabi$iconset = _Vizabi.iconset,
    iconWarn = _Vizabi$iconset.warn,
    iconQuestion = _Vizabi$iconset.question;

// BUBBLE MAP CHART COMPONENT

var CartogramComponent = Vizabi.Component.extend("cartogram", {
  /**
   * Initializes the component (Bubble Map Chart).
   * Executed once before any template is rendered.
   * @param {Object} config The config passed to the component
   * @param {Object} context The component's parent
   */
  init: function init(config, context) {
    this.name = "cartogram";
    this.template = __webpack_require__(4);

    this.isMobile = utils.isMobileOrTablet();

    //define expected models for this component
    this.model_expects = [{
      name: "time",
      type: "time"
    }, {
      name: "entities",
      type: "entities"
    }, {
      name: "marker",
      type: "marker"
    }, {
      name: "locale",
      type: "locale"
    }, {
      name: "ui",
      type: "ui"
    }];

    var _this = this;
    this.model_binds = {
      "change:time.value": function changeTimeValue(evt) {
        if (!_this._readyOnce) return;
        if (!_this.calculationQueue) {
          // collect timestamp that we request
          _this.calculationQueue = [_this.model.time.value.toString()];
        } else {
          _this.calculationQueue.push(_this.model.time.value.toString());
        }
        (function (time) {
          // isolate timestamp
          _this.model.marker.getFrame(time, function (frame, time) {
            var index = _this.calculationQueue.indexOf(time.toString()); //
            if (index == -1) {
              // we was receive more recent frame before so we pass this frame
              return;
            }
            _this.calculationQueue.splice(0, index + 1); // remove timestamps that added to queue before current timestamp
            _this.frameChanged(frame, time);
          });
        })(_this.model.time.value);
      },
      "change:marker.size.extent": function changeMarkerSizeExtent(evt, path) {
        //console.log("EVENT change:marker:size:max");
        if (!_this._readyOnce) return;
        _this.updateMarkerSizeLimits();
        _this.updateEntities();
      },
      "change:marker.color.scaleType": function changeMarkerColorScaleType(evt, path) {
        _this.updateIndicators();
        _this.updateEntitityColor();
      },

      "change:marker.size.use": function changeMarkerSizeUse(evt, path) {
        _this.model.ui.chart.lockActive = _this.model.marker.size.use != "constant";
      },
      "change:marker.color.palette": function changeMarkerColorPalette(evt, path) {
        _this.updateEntitityColor();
      },
      "change:ui.chart.lockNonSelected": function changeUiChartLockNonSelected(evt) {
        _this.updateEntities(900);
      },
      "change:marker.select": function changeMarkerSelect() {
        if (!_this._readyOnce) return;
        _this.updateLandOpacity();
      },
      "change:marker.highlight": function changeMarkerHighlight() {
        if (!_this._readyOnce) return;
        //console.log("EVENT change:entities:highlight");
        _this.updateLandOpacity();
      },
      "change:marker.opacitySelectDim": function changeMarkerOpacitySelectDim() {
        _this.updateLandOpacity();
      },
      "change:marker.opacityRegular": function changeMarkerOpacityRegular() {
        _this.updateLandOpacity();
      }
    };
    //this._selectlist = new Selectlist(this);

    //contructor is the same as any component
    this._super(config, context);

    _this.COLOR_LAND_DEFAULT = "#fdfdfd";

    this.mapLands = null;
    this.features = null;
    this.topo_features = null;
    this.borderArcs = null;
    this.defaultWidth = 700;
    this.defaultHeight = 550;
    this.updateEntitiesQueue = [];
    d3GeoProjection();
    this.cached = [];

    var projection = "geo" + utils.capitalize(this.model.ui.map.projection);

    this.zeroProjection = d3[projection]().scale(1).translate([0, 0]);

    this.projection = d3[projection]().scale(1).translate([0, 0]);

    this.mapPath = d3.geoPath().projection(this.projection);

    this.cartogram = d3.cartogram().projection(this.projection).properties(function (d) {
      return d.properties;
    });

    this._labels = new Labels(this);
    this._labels.config({
      CSS_PREFIX: "vzb-ct",
      LABELS_CONTAINER_CLASS: "vzb-ct-labels",
      LINES_CONTAINER_CLASS: "vzb-ct-lines"
    });
  },
  afterPreload: function afterPreload() {
    var _this = this;
    if (!this.world) utils.warn("cartogram afterPreload: missing country shapes " + this.world);
    if (!this.geometries) utils.warn("cartogram afterPreload: missing country shapes " + this.geometries);
  },
  _getKey: function _getKey(d) {
    return d.properties[this.model.ui.map.topology.geoIdProperty] && this.mapKeys[d.properties[this.model.ui.map.topology.geoIdProperty]] ? this.mapKeys[d.properties[this.model.ui.map.topology.geoIdProperty]].toString() : d.id.toString();
  },

  /**
   * DOM is ready
   */
  readyOnce: function readyOnce() {
    var _this2 = this;

    var _this = this;
    this.element = d3.select(this.element);

    this.graph = this.element.select(".vzb-ct-graph");
    this.mapSvg = this.element.select(".vzb-ct-map-background");

    this.labelsContainerCrop = this.graph.select(".vzb-ct-labels-crop");
    this.labelsContainer = this.graph.select(".vzb-ct-labels");

    this.sTitleEl = this.graph.select(".vzb-ct-axis-s-title");
    this.cTitleEl = this.graph.select(".vzb-ct-axis-c-title");

    this.sInfoEl = this.graph.select(".vzb-ct-axis-s-info");
    this.cInfoEl = this.graph.select(".vzb-ct-axis-c-info");

    this.dataWarningEl = this.graph.select(".vzb-data-warning");
    this.entityBubbles = null;
    this.tooltip = this.element.select(".vzb-ct-tooltip");

    // year background
    this.yearEl = this.graph.select(".vzb-ct-year");
    this.year = new DynamicBackground(this.yearEl);
    this.year.setConditions({ xAlign: "left", yAlign: "bottom", bottomOffset: 5 });

    this.mapGraph = this.element.select(".vzb-ct-map-graph").attr("width", this.defaultWidth).attr("height", this.defaultHeight);
    this.mapGraph.html("");

    this.showAreas();
    this.KEY = this.model.entities.getDimension();
    this.TIMEDIM = this.model.time.getDimension();

    this.updateUIStrings();
    this.on("resize", function () {
      return _this2.updateSize();
    });
    this.wScale = d3.scaleLinear().domain(this.model.ui.datawarning.doubtDomain).range(this.model.ui.datawarning.doubtRange);

    /*
    */
  },
  frameChanged: function frameChanged(frame, time) {
    if (time.toString() != this.model.time.value.toString()) return; // frame is outdated
    if (!frame) return;
    this.values = frame;
    this.updateTime();
    this.updateTitleNumbers();
    this.updateEntities(this.duration);
  },


  /*
   * Both model and DOM are ready
   */
  ready: function ready() {
    var _this = this;
    this.cached = [];
    this.updateIndicators();
    this.updateUIStrings();
    this.updateMarkerSizeLimits();
    this.updateSize();
    this.model.marker.getFrame(_this.model.time.value, function (frame, time) {
      _this.mapKeys = Object.keys(frame.hook_map).reduce(function (obj, key) {
        obj[frame.hook_map[key]] = key;
        return obj;
      }, {});
      _this.frameChanged(frame, time);
    });
  },
  showAreas: function showAreas() {
    var _this = this;
    this.cartogram.iterations(0);
    this.redrawInProgress = true;

    this.cartogram(this.shapes, this.geometries).then(function (response) {
      _this.redrawInProgress = false;

      _this.features = _this.topo_features = response.features;
      _this.mapLands = _this.mapGraph.selectAll(".land").data(_this.topo_features).enter().append("path").attr("class", function (d) {
        return "land " + (d.properties[_this.model.ui.map.topology.geoIdProperty] ? d.properties[_this.model.ui.map.topology.geoIdProperty] : d.id);
      }).attr("d", _this.cartogram.path).on("mouseover", function (d, i) {
        if (utils.isTouchDevice()) return;
        _this._interact()._mouseover(d, i);
      }).on("mouseout", function (d, i) {
        if (utils.isTouchDevice()) return;
        _this._interact()._mouseout(d, i);
      }).on("click", function (d, i) {
        if (utils.isTouchDevice()) return;
        _this._interact()._click(d, i);
      }).each(function (d) {
        d[_this.KEY] = _this._getKey(d);
      });
      if (_this.borderArcs) {
        var data = _this.cartogram.stitchArcs(response, _this.borderArcs);
        _this.borders = _this.mapGraph.append("path").datum(data).attr("class", "boundary").attr("d", _this.cartogram.path);
      }
    });
  },


  /**
   * Changes labels for indicators
   */
  updateIndicators: function updateIndicators() {
    this.sScale = this.model.marker.size.getScale();
    this.cScale = this.model.marker.color.getScale();
  },
  updateMarkerSizeLimits: function updateMarkerSizeLimits() {
    var _this = this;
    var extent = this.model.marker.size.extent || [0, 1];
    this.minRadius = Math.max(100 * extent[0], 0);
    this.maxRadius = Math.max(100 * extent[1], 0);

    this.sScale.domain([0, this.sScale.domain()[1]]);
    if (this.model.marker.size.scaleType !== "ordinal") {
      this.sScale.range([this.minRadius, this.maxRadius]);
    } else {
      this.sScale.rangePoints([this.minRadius, this.maxRadius], 0).range();
    }
  },
  _redrawEntities: function _redrawEntities() {
    var _this = this;
    if (this.updateEntitiesQueue.length == 0) return;
    if (this.redrawInProgress) {
      setTimeout(function () {
        _this._redrawEntities();
      }, 100);
      return;
    }
    this.redrawInProgress = true;
    var time = this.updateEntitiesQueue[this.updateEntitiesQueue.length - 1].time;
    var duration = this.updateEntitiesQueue[this.updateEntitiesQueue.length - 1].duration;
    this.updateEntitiesQueue = [];
    if (this.model.ui.chart.lockNonSelected) {
      time = this.model.time.parse("" + this.model.ui.chart.lockNonSelected);
    }
    this.model.marker.getFrame(time, function (lockedFrame) {
      var totValue = null;
      if (_this.model.marker.size.use == "constant") {
        _this.cartogram.iterations(0);
      } else {
        _this.cartogram.iterations(8);
        //var areas = _this.topo_features.map(d3.geo.path().projection(null).area);
        _this.cartogram.value(function (d) {
          if (_this.model.ui.chart.lockNonSelected) {
            var size1 = _this.sScale(lockedFrame.size[_this._getKey(d)]);
            var size2 = _this.sScale(_this.values.size[_this._getKey(d)]);
            return d3.geo.path().projection(null).area(d) * Math.pow(size2 / size1, 2);
          }
          return _this.sScale(_this.values.size[_this._getKey(d)]);
        });
      }
      var start = new Date().getTime();
      _this.cartogram(_this.shapes, _this.geometries, totValue).then(function (response) {
        var end = new Date().getTime();
        if (duration) {
          // increale duration for prevent gaps between frames
          duration = Math.max(duration, end - start);
        }
        _this.features = response.features;
        if (_this.borderArcs) {
          var data = _this.cartogram.stitchArcs(response, _this.borderArcs);
          _this.borders.datum(data).transition().duration(duration).ease(d3.easeLinear).attr("d", _this.cartogram.path);
        }
        _this.mapLands.data(_this.features).each(function (d) {
          d[_this.KEY] = _this._getKey(d);
        });
        if (duration) {
          _this.mapLands.interrupt().transition().duration(duration).ease(d3.easeLinear).style("fill", function (d) {
            return _this.values.color[_this._getKey(d)] != null ? _this.cScale(_this.values.color[_this._getKey(d)]) : _this.COLOR_LAND_DEFAULT;
          }).attr("d", _this.cartogram.path);
          if (_this.borderArcs) {
            _this.borders.interrupt().transition().duration(duration).ease(d3.easeLinear).attr("d", _this.cartogram.path);
          }
        } else {
          _this.borders.attr("d", _this.cartogram.path);

          _this.mapLands.style("fill", function (d) {
            return _this.values.color[_this._getKey(d)] != null ? _this.cScale(_this.values.color[_this._getKey(d)]) : _this.COLOR_LAND_DEFAULT;
          }).attr("d", _this.cartogram.path);
        }
        _this.updateLandOpacity();
        _this.redrawInProgress = false;
        _this._redrawEntities();
      });
    });
  },
  updateEntities: function updateEntities(duration) {
    var time = this.model.time.value;

    this.updateEntitiesQueue.push({ time: time, duration: duration });
    this._redrawEntities();
  },
  updateEntitityColor: function updateEntitityColor() {
    var _this = this;
    this.mapLands.transition().duration(_this.duration).ease(d3.easeLinear).style("fill", function (d) {
      return _this.values.color[_this._getKey(d)] != null ? _this.cScale(_this.values.color[_this._getKey(d)]) : _this.COLOR_LAND_DEFAULT;
    });
  },
  updateUIStrings: function updateUIStrings() {
    var _this = this;

    this.translator = this.model.locale.getTFunction();

    var conceptPropsS = _this.model.marker.size.getConceptprops();
    var conceptPropsC = _this.model.marker.color.getConceptprops();

    this.strings = {
      title: {
        S: conceptPropsS.name,
        C: conceptPropsC.name
      }
    };

    this.sTitleEl.select("text").text(this.translator("buttons/size") + ": " + this.strings.title.S).on("click", function () {
      _this.parent.findChildByName("gapminder-treemenu").markerID("size").alignX(_this.model.locale.isRTL() ? "right" : "left").alignY("top").updateView().toggle();
    });

    this.cTitleEl.select("text").text(this.translator("buttons/color") + ": " + this.strings.title.C).on("click", function () {
      _this.parent.findChildByName("gapminder-treemenu").markerID("color").alignX(_this.model.locale.isRTL() ? "right" : "left").alignY("top").updateView().toggle();
    });

    utils.setIcon(this.dataWarningEl, iconWarn).select("svg").attr("width", "0px").attr("height", "0px");
    this.dataWarningEl.append("text").attr("text-anchor", "end").text(this.translator("hints/dataWarning"));

    this.dataWarningEl.on("click", function () {
      _this.parent.findChildByName("gapminder-datawarning").toggle();
    }).on("mouseover", function () {
      _this.updateDoubtOpacity(1);
    }).on("mouseout", function () {
      _this.updateDoubtOpacity();
    });

    this.sInfoEl.html(iconQuestion).select("svg").attr("width", "0px").attr("height", "0px");

    //TODO: move away from UI strings, maybe to ready or ready once
    this.sInfoEl.on("click", function () {
      _this.parent.findChildByName("gapminder-datanotes").pin();
    });
    this.sInfoEl.on("mouseover", function () {
      var rect = this.getBBox();
      var coord = utils.makeAbsoluteContext(this, this.farthestViewportElement)(rect.x - 10, rect.y + rect.height + 10);
      var toolRect = _this.root.element.getBoundingClientRect();
      var chartRect = _this.element.node().getBoundingClientRect();
      _this.parent.findChildByName("gapminder-datanotes").setHook("size").show().setPos(coord.x + chartRect.left - toolRect.left, coord.y);
    });
    this.sInfoEl.on("mouseout", function () {
      _this.parent.findChildByName("gapminder-datanotes").hide();
    });

    this.cInfoEl.html(iconQuestion).select("svg").attr("width", "0px").attr("height", "0px");

    //TODO: move away from UI strings, maybe to ready or ready once
    this.cInfoEl.on("click", function () {
      _this.parent.findChildByName("gapminder-datanotes").pin();
    });
    this.cInfoEl.on("mouseover", function () {
      var rect = this.getBBox();
      var coord = utils.makeAbsoluteContext(this, this.farthestViewportElement)(rect.x - 10, rect.y + rect.height + 10);
      var toolRect = _this.root.element.getBoundingClientRect();
      var chartRect = _this.element.node().getBoundingClientRect();
      _this.parent.findChildByName("gapminder-datanotes").setHook("color").show().setPos(coord.x + chartRect.left - toolRect.left, coord.y);
    });
    this.cInfoEl.on("mouseout", function () {
      _this.parent.findChildByName("gapminder-datanotes").hide();
    });
  },
  updateDoubtOpacity: function updateDoubtOpacity(opacity) {
    if (opacity == null) opacity = this.wScale(+this.time.getUTCFullYear().toString());
    if (this.someSelected) opacity = 1;
    this.dataWarningEl.style("opacity", opacity);
  },


  /*
   * UPDATE TIME:
   * Ideally should only update when time or data changes
   */
  updateTime: function updateTime() {
    var _this = this;
    this.time_1 = this.time == null ? this.model.time.value : this.time;
    this.time = this.model.time.value;
    this.duration = this.model.time.playing && this.time - this.time_1 > 0 ? this.model.time.delayAnimations : 0;
    this.year.setText(this.model.time.formatDate(this.time), this.duration);
  },


  /**
   * Executes everytime the container or vizabi is resized
   * Ideally,it contains only operations related to size
   */
  updateSize: function updateSize() {
    var profiles = {
      small: {
        margin: { top: 10, right: 10, left: 10, bottom: 0 },
        infoElHeight: 16
      },
      medium: {
        margin: { top: 20, right: 20, left: 20, bottom: 30 },
        infoElHeight: 20
      },
      large: {
        margin: { top: 30, right: 30, left: 30, bottom: 35 },
        infoElHeight: 22
      }
    };

    var presentationProfileChanges = {
      medium: {
        infoElHeight: 26
      },
      large: {
        infoElHeight: 32
      }
    };

    this.activeProfile = this.getActiveProfile(profiles, presentationProfileChanges);
    var margin = this.activeProfile.margin;
    var infoElHeight = this.activeProfile.infoElHeight;

    //stage

    var height = this.height = parseInt(this.element.style("height"), 10) - margin.top - margin.bottom || 0;
    var width = this.width = parseInt(this.element.style("width"), 10) - margin.left - margin.right || 0;

    if (this.height <= 0 || this.width <= 0) return utils.warn("Bubble map updateSize() abort: vizabi container is too little or has display:none");

    var scaleDelta = 1,
        mapTopOffset = 0,
        mapLeftOffset = 0;
    var currentNW = this.zeroProjection([this.model.ui.map.bounds.west, this.model.ui.map.bounds.north]);
    var currentSE = this.zeroProjection([this.model.ui.map.bounds.east, this.model.ui.map.bounds.south]);
    var canvas = [[0, 0], [width, height]];
    if (this.model.ui.map.preserveAspectRatio) {
      mapTopOffset = margin.top;
      mapLeftOffset = margin.left;
      var scaleX = Math.abs((canvas[1][0] - canvas[0][0]) / (currentSE[0] - currentNW[0]));
      var scaleY = Math.abs((canvas[1][1] - canvas[0][1]) / (currentSE[1] - currentNW[1]));
      if (scaleX != scaleY) {
        if (scaleX > scaleY) {
          scaleDelta = scaleY;
          mapLeftOffset += (Math.abs(canvas[1][0] - canvas[0][0]) - Math.abs(scaleDelta * (currentNW[1] - currentSE[1]))) / 2;
        } else {
          scaleDelta = scaleX;
          mapTopOffset += (Math.abs(canvas[1][1] - canvas[0][1]) - Math.abs(scaleDelta * (currentNW[0] - currentSE[0]))) / 2;
        }
      }
    } else {
      scaleDelta = Math.abs((canvas[1][0] - canvas[0][0]) / (currentSE[0] - currentNW[0]));
    }

    this.graph.attr("transform", "translate(" + margin.left + "," + margin.top + ")");

    this.year.resize(this.width, this.height);

    this.mapSvg.attr("width", width).attr("height", height).attr("preserveAspectRatio", "xMidYMid").attr("x", margin.left).attr("y", margin.top).style("transform", "translate3d(" + margin.left + "px," + margin.top + "px,0)");

    this.projection.translate([canvas[0][0] - currentNW[0] * scaleDelta + mapLeftOffset - margin.left, canvas[0][1] - currentNW[1] * scaleDelta + mapTopOffset - margin.top]).scale(scaleDelta).precision(0.1);
    this.cartogram.projection(this.projection);
    this.updateEntities();

    this.year.setConditions({
      widthRatio: 2 / 10
    });
    this.year.resize(this.width, this.height);

    this.cTitleEl.style("font-size", infoElHeight).attr("transform", "translate(0," + margin.top + ")");

    var cTitleBB = this.cTitleEl.select("text").node().getBBox();

    this.sTitleEl.attr("transform", "translate(" + 0 + "," + (margin.top + cTitleBB.height) + ")").classed("vzb-hidden", this.model.marker.size.use == "constant");

    var warnBB = this.dataWarningEl.select("text").node().getBBox();
    this.dataWarningEl.select("svg").attr("width", warnBB.height * 0.75).attr("height", warnBB.height * 0.75).attr("x", -warnBB.width - warnBB.height * 1.2).attr("y", -warnBB.height * 0.65);

    this.dataWarningEl.attr("transform", "translate(" + this.width + "," + (this.height - warnBB.height * 0.5) + ")").select("text");

    if (this.sInfoEl.select("svg").node()) {
      var titleBBox = this.sTitleEl.node().getBBox();
      var translate = [0, 0]; //d3.transform(this.yTitleEl.attr("transform")).translate;

      this.sInfoEl.select("svg").attr("width", infoElHeight).attr("height", infoElHeight);
      this.sInfoEl.attr("transform", "translate(" + (titleBBox.x + translate[0] + titleBBox.width + infoElHeight * 0.4) + "," + (translate[1] - infoElHeight * 0.8) + ")");
    }

    this.cInfoEl.classed("vzb-hidden", this.cTitleEl.classed("vzb-hidden"));

    if (!this.cInfoEl.classed("vzb-hidden") && this.cInfoEl.select("svg").node()) {
      var _titleBBox = this.cTitleEl.node().getBBox();
      var _translate = [0, 0]; //d3.transform(this.sTitleEl.attr("transform")).translate;

      this.cInfoEl.select("svg").attr("width", infoElHeight).attr("height", infoElHeight);
      this.cInfoEl.attr("transform", "translate(" + (_titleBBox.x + _translate[0] + _titleBBox.width + infoElHeight * 0.4) + "," + (_translate[1] - infoElHeight * 0.8) + ")");
    }
  },
  fitSizeOfTitles: function fitSizeOfTitles() {

    //reset font sizes first to make the measurement consistent
    var cTitleText = this.cTitleEl.select("text").style("font-size", null);
    var sTitleText = this.sTitleEl.select("text").style("font-size", null);

    var cTitleBB = cTitleText.node().getBBox();
    var sTitleBB = this.sTitleEl.classed("vzb-hidden") ? cTitleBB : sTitleText.node().getBBox();

    var font = Math.max(parseInt(cTitleText.style("font-size")), parseInt(sTitleText.style("font-size"))) * this.width / Math.max(cTitleBB.width, sTitleBB.width);

    if (Math.max(cTitleBB.width, sTitleBB.width) > this.width) {
      cTitleText.style("font-size", font + "px");
      sTitleText.style("font-size", font + "px");
    } else {
      // Else - reset the font size to default so it won't get stuck
      cTitleText.style("font-size", null);
      sTitleText.style("font-size", null);
    }
  },
  _interact: function _interact() {
    var _this = this;

    return {
      _mouseover: function _mouseover(d, i) {
        if (_this.model.time.dragging) return;

        _this.model.marker.highlightMarker(d);

        _this.hovered = d;
        //put the exact value in the size title
        _this.updateTitleNumbers();
        _this.fitSizeOfTitles();

        if (_this.model.marker.isSelected(d)) {
          // if selected, not show hover tooltip
          _this._setTooltip();
        } else {
          //position tooltip
          _this._setTooltip(d);
        }
      },
      _mouseout: function _mouseout(d, i) {
        if (_this.model.time.dragging) return;
        _this._setTooltip();
        _this.hovered = null;
        _this.updateTitleNumbers();
        _this.fitSizeOfTitles();
        _this.model.marker.clearHighlighted();
      },
      _click: function _click(d, i) {
        _this.model.marker.selectMarker(d);
      }
    };
  },


  // show size number on title when hovered on a bubble
  updateTitleNumbers: function updateTitleNumbers() {
    var _this = this;

    var mobile = void 0; // if is mobile device and only one bubble is selected, update the ytitle for the bubble
    if (_this.isMobile && _this.model.marker.select && _this.model.marker.select.length === 1) {
      mobile = _this.model.marker.select[0];
    }

    if (_this.hovered || mobile) {
      var hovered = _this.hovered || mobile;
      var formatterC = _this.model.marker.color.getTickFormatter();

      var unitC = _this.translator("unit/" + _this.model.marker.color.which);
      //suppress unit strings that found no translation (returns same thing as requested)
      if (unitC === "unit/" + _this.model.marker.color.which) unitC = "";

      var valueC = _this.values.color[_this._getKey(hovered)];
      _this.cTitleEl.select("text").text(this.strings.title.C + ": " + (valueC || valueC === 0 ? formatterC(valueC) + " " + unitC : _this.translator("hints/nodata")));

      if (this.model.marker.size.use !== "constant") {
        var formatterS = _this.model.marker.size.getTickFormatter();

        var unitS = _this.translator("unit/" + _this.model.marker.size.which);
        //suppress unit strings that found no translation (returns same thing as requested)
        if (unitS === "unit/" + _this.model.marker.size.which) unitS = "";

        var valueS = _this.values.size[_this._getKey(hovered)];
        _this.sTitleEl.select("text").text(this.strings.title.S + ": " + formatterS(valueS) + " " + unitS);
      }

      this.cInfoEl.classed("vzb-hidden", true);
      this.sInfoEl.classed("vzb-hidden", true);
    } else {
      this.cTitleEl.select("text").text(this.strings.title.C);
      this.sTitleEl.select("text").text(this.strings.title.S);

      this.cInfoEl.classed("vzb-hidden", false);
      this.sInfoEl.classed("vzb-hidden", false);
    }
  },
  _setTooltip: function _setTooltip(d) {
    var _this = this;
    if (d) {
      var tooltipText = this.values.label[this._getKey(d)] ? this.values.label[this._getKey(d)] : d.properties.MN_NAME;
      var offset = 10;
      var mouse = d3.mouse(this.graph.node()).map(function (d) {
        return parseInt(d);
      });
      var x = mouse[0];
      var y = mouse[1];
      var xPos = void 0,
          yPos = void 0,
          xSign = -1,
          ySign = -1,
          xOffset = 0,
          yOffset = 0;

      if (offset) {
        xOffset = offset * 0.71; // .71 - sin and cos for 315
        yOffset = offset * 0.71;
      }
      //position tooltip
      this.tooltip.classed("vzb-hidden", false)
      //.attr("style", "left:" + (mouse[0] + 50) + "px;top:" + (mouse[1] + 50) + "px")
      .selectAll("text").text(tooltipText);

      var contentBBox = this.tooltip.select("text").node().getBBox();
      if (x - xOffset - contentBBox.width < 0) {
        xSign = 1;
        x += contentBBox.width + 5; // corrective to the block Radius and text padding
      } else {
        x -= 5; // corrective to the block Radius and text padding
      }
      if (y - yOffset - contentBBox.height < 0) {
        ySign = 1;
        y += contentBBox.height;
      } else {
        y -= 11; // corrective to the block Radius and text padding
      }
      if (offset) {
        xPos = x + xOffset * xSign;
        yPos = y + yOffset * ySign; // 5 and 11 - corrective to the block Radius and text padding
      } else {
        xPos = x + xOffset * xSign; // .71 - sin and cos for 315
        yPos = y + yOffset * ySign; // 5 and 11 - corrective to the block Radius and text padding
      }
      this.tooltip.attr("transform", "translate(" + (xPos ? xPos : mouse[0]) + "," + (yPos ? yPos : mouse[1]) + ")");

      this.tooltip.select("rect").attr("width", contentBBox.width + 8).attr("height", contentBBox.height * 1.2).attr("x", -contentBBox.width - 4).attr("y", -contentBBox.height * 0.85).attr("rx", contentBBox.height * 0.2).attr("ry", contentBBox.height * 0.2);
    } else {

      this.tooltip.classed("vzb-hidden", true);
    }
  },
  updateLandOpacity: function updateLandOpacity() {
    var _this = this;
    //if(!duration)duration = 0;

    var OPACITY_HIGHLT = 0.8;
    var OPACITY_HIGHLT_DIM = 0.3;
    var OPACITY_SELECT = 1.0;
    var OPACITY_REGULAR = this.model.marker.opacityRegular;
    var OPACITY_SELECT_DIM = this.model.marker.opacitySelectDim;
    this.someHighlighted = this.model.marker.highlight.length > 0;
    this.someSelected = this.model.marker.select.length > 0;
    this.mapLands.style("opacity", function (d) {

      if (_this.someHighlighted) {
        //highlight or non-highlight
        if (_this.model.marker.isHighlighted(d)) return OPACITY_HIGHLT;
      }

      if (_this.someSelected) {
        //selected or non-selected
        return _this.model.marker.isSelected(d) ? OPACITY_SELECT : OPACITY_SELECT_DIM;
      }

      if (_this.someHighlighted) return OPACITY_HIGHLT_DIM;

      return OPACITY_REGULAR;
    });

    var someSelectedAndOpacityZero = _this.someSelected && _this.model.marker.opacitySelectDim < 0.01;

    // when pointer events need update...
    if (someSelectedAndOpacityZero != this.someSelectedAndOpacityZero_1) {
      this.mapLands.style("pointer-events", function (d) {
        return !someSelectedAndOpacityZero || _this.model.marker.isSelected(d) ? "visible" : "none";
      });
    }

    this.someSelectedAndOpacityZero_1 = _this.someSelected && _this.model.marker.opacitySelectDim < 0.01;
  },
  preload: function preload() {
    var _this = this;
    var shape_path = this.model.ui.map.topology.path || this.model.data.assetsPath + "world-50m.json";

    var projection = "geo" + utils.capitalize(this.model.ui.map.projection);

    this.zeroProjection = d3[projection]();
    this.zeroProjection.scale(1).translate([0, 0]);

    this.projection = d3[projection]();
    this.projection.scale(1).translate([0, 0]);

    this.mapPath = d3.geoPath().projection(this.projection);

    this.model.ui.map.scale = 1;
    return this._loadShapes(shape_path).then(function (shapes) {
      _this.shapes = shapes;
      _this.geometries = _this.shapes.objects[_this.model.ui.map.topology.objects.boundaries].geometries;
      _this.mapFeature = topojson.feature(_this.shapes, _this.shapes.objects[_this.model.ui.map.topology.objects.geo]);
      _this.mapBounds = _this.mapPath.bounds(_this.mapFeature);
      _this.boundaries = topojson.mesh(_this.shapes, _this.shapes.objects[_this.model.ui.map.topology.objects.boundaries], function (a, b) {
        return a !== b;
      });
      _this.borderArcs = _this.cartogram.meshArcs(_this.shapes, _this.shapes.objects[_this.model.ui.map.topology.objects.boundaries], function (a, b) {
        a.properties[_this.model.ui.map.topology.geoIdProperty] && a.properties[_this.model.ui.map.topology.geoIdProperty] !== b.properties[_this.model.ui.map.topology.geoIdProperty];
      });
    });
  },
  _loadShapes: function _loadShapes(shape_path) {
    return new Promise(function (resolve, reject) {
      d3.json(shape_path, function (error, json) {
        if (error) return console.warn("Failed loading json " + shape_path + ". " + error);
        resolve(json);
      });
    });
  }
});

exports.default = CartogramComponent;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _Vizabi = Vizabi,
    utils = _Vizabi.utils,
    topojson = _Vizabi.helpers.topojson;

/*
 * d3.cartogram is a d3-friendly implementation of An Algorithm to Construct
 * Continuous Area Cartograms:
 *
 * <http://chrisman.scg.ulaval.ca/G360/dougenik.pdf>
 *
 * It requires topojson to decode TopoJSON-encoded topologies:
 *
 * <http://github.com/mbostock/topojson/>
 *
 * Usage:
 *
 * var cartogram = d3.cartogram()
 *  .projection(d3.geo.albersUsa())
 *  .value(function(d) {
 *    return Math.random() * 100;
 *  });
 * d3.json("path/to/topology.json", function(topology) {
 *  var features = cartogram(topology, topology.objects.OBJECTNAME.geometries);
 *  d3.select("svg").selectAll("path")
 *    .data(features)
 *    .enter()
 *    .append("path")
 *      .attr("d", cartogram.path);
 * });
 */

d3.cartogram = function () {

  function carto(topology, geometries, totalValue) {

    var calculateObjectsMeta = function calculateObjectsMeta(objects, values, path) {
      return new Promise(function (resolve, reject) {
        var areas = objects.map(path.area);
        var totalArea = d3.sum(areas),
            sizeErrorsTot = 0,
            sizeErrorsNum = 0;

        var calculateMeta = function calculateMeta(index, cb) {
          var area = Math.abs(areas[index]),
              // XXX: why do we have negative areas?
          v = +values[index],
              desired = totalArea * v / totalValue,
              radius = Math.sqrt(area / Math.PI),
              mass = Math.sqrt(desired / Math.PI) - radius,
              sizeError = Math.max(area, desired) / Math.min(area, desired);
          // console.log(o.id, "@", j, "area:", area, "value:", v, "->", desired, radius, mass, sizeError);
          cb({
            id: objects[index].id,
            area: area,
            centroid: path.centroid(objects[index]),
            value: v,
            desired: desired,
            radius: radius,
            mass: mass,
            sizeError: sizeError
          });
        };
        var calculateMetaSequence = function calculateMetaSequence(index) {
          if (index >= objects.length) {
            return resolve({ meta: meta, sizeError: sizeErrorsTot / sizeErrorsNum });
          }
          calculateMeta(index, function (response) {
            meta.push(response);
            sizeErrorsTot += response.sizeError;
            sizeErrorsNum++;
            if (index % 400 == 0) {
              utils.defer(function () {
                calculateMetaSequence(++index);
              });
            } else {
              calculateMetaSequence(++index);
            }
          });
        };
        var meta = [];
        calculateMetaSequence(0);
      });
    };
    // copy it first
    return new Promise(function (resolve, reject) {
      topology = copy(topology);

      // objects are projected into screen coordinates

      // project the arcs into screen space
      var tf = transformer(topology.transform),
          x,
          y,
          len1,
          i1,
          out1,
          len2 = topology.arcs.length,
          i2 = 0,
          projectedArcs = new Array(len2);
      var projectedArcsDeferResolver = void 0;
      var projectedArcsDefer = new Promise(function (resolve, reject) {
        projectedArcsDeferResolver = resolve;
      });
      var generateTopologySegment = function generateTopologySegment(segmentIndex, segmentLength) {
        return new Promise(function (resolve, reject) {
          i1 = 0;
          while (i1 < segmentLength) {
            topology.arcs[segmentIndex][i1][0] = x += topology.arcs[segmentIndex][i1][0];
            topology.arcs[segmentIndex][i1][1] = y += topology.arcs[segmentIndex][i1][1];
            out1[i1] = projection === null ? tf(topology.arcs[segmentIndex][i1]) : projection(tf(topology.arcs[segmentIndex][i1]));
            i1++;
          }
          resolve(out1);
        });
      };
      var generateTopologyArcs = function generateTopologyArcs(index, totalLength) {
        if (index >= totalLength) {
          return projectedArcsDeferResolver(projectedArcs);
        }
        x = 0;
        y = 0;
        len1 = topology.arcs[index].length;
        i1 = 0;
        out1 = new Array(len1);

        generateTopologySegment(index, len1).then(function (segment) {
          projectedArcs[index++] = segment;
          if (index % 400 == 0) {
            utils.defer(function () {
              generateTopologyArcs(index, totalLength);
            });
          } else {
            generateTopologyArcs(index, totalLength);
          }
        });
      };
      generateTopologyArcs(0, len2);

      projectedArcsDefer.then(function (projectedArcs) {
        // path with identity projection
        var path = d3.geoPath().projection(null);
        var objects = object(projectedArcs, { type: "GeometryCollection", geometries: geometries }).geometries.map(function (geom) {
          return {
            type: "Feature",
            id: geom.id,
            properties: properties.call(null, geom, topology),
            geometry: geom
          };
        });
        var values = objects.map(value);
        if (!totalValue) {
          totalValue = d3.sum(values);
        }
        // no iterations; just return the features
        if (iterations <= 0) {
          resolve({
            features: objects,
            arcs: projectedArcs
          });
        }
        var i = 0;
        var resizeSegments = function resizeSegments(index, iterations) {
          if (index >= iterations) {
            return iterationsDeferResolver();
          }
          calculateObjectsMeta(objects, values, path).then(function (response) {
            var forceReductionFactor = 1 / (1 + response.sizeError);

            // console.log("meta:", meta);
            // console.log("  total area:", totalArea);
            // console.log("  force reduction factor:", forceReductionFactor, "mean error:", sizeError);
            var delta, centroid, mass, radius, rSquared, dx, dy, distSquared, dist, Fij;
            var updatePoint = function updatePoint(i2, len2) {
              var len1, i1, delta, len3, i3, centroid, mass, radius, rSquared, dx, dy, distSquared, dist, Fij;
              while (i2 < len2) {
                len1 = projectedArcs[i2].length;
                i1 = 0;
                while (i1 < len1) {
                  // create an array of vectors: [x, y]
                  delta = [0, 0];
                  len3 = response.meta.length;
                  i3 = 0;
                  while (i3 < len3) {
                    centroid = response.meta[i3].centroid;
                    mass = response.meta[i3].mass;
                    radius = response.meta[i3].radius;
                    rSquared = radius * radius;
                    dx = projectedArcs[i2][i1][0] - centroid[0];
                    dy = projectedArcs[i2][i1][1] - centroid[1];
                    distSquared = dx * dx + dy * dy;
                    dist = Math.sqrt(distSquared);
                    Fij = dist > radius ? mass * radius / dist : mass * (distSquared / rSquared) * (4 - 3 * dist / radius);
                    delta[0] += Fij * cosArctan(dy, dx);
                    delta[1] += Fij * sinArctan(dy, dx);
                    i3++;
                  }
                  projectedArcs[i2][i1][0] += delta[0] * forceReductionFactor;
                  projectedArcs[i2][i1][1] += delta[1] * forceReductionFactor;
                  i1++;
                }
                i2++;
              }
            };
            var updatePointSequence = function updatePointSequence(start) {
              if (start >= projectedArcs.length) {
                if (response.sizeError <= 1) {
                  resizeSegments(iterations, iterations);
                  return;
                }
                utils.defer(function () {
                  resizeSegments(++index, iterations);
                });
                return;
              }
              var end = Math.min(start + 400, projectedArcs.length);
              updatePoint(start, end);
              utils.defer(function () {
                updatePointSequence(end);
              });
            };
            updatePointSequence(0);
            // break if we hit the target size error
          });
        };
        var iterationsDeferResolver = void 0;
        var iterationsDefer = new Promise(function (resolve, reject) {
          iterationsDeferResolver = resolve;
        });
        resizeSegments(0, iterations);
        iterationsDefer.then(function () {
          resolve({
            features: objects,
            arcs: projectedArcs
          });
        });
      });

      /*
       while(i2<len2){
       x = 0;
       y = 0;
       len1 = topology.arcs[i2].length;
       i1 = 0;
       out1 = new Array(len1);
       while(i1<len1){
       topology.arcs[i2][i1][0] = (x += topology.arcs[i2][i1][0]);
       topology.arcs[i2][i1][1] = (y += topology.arcs[i2][i1][1]);
       out1[i1] = projection === null ? tf(topology.arcs[i2][i1]) : projection(tf(topology.arcs[i2][i1]));
       i1++;
       }
       projectedArcs[i2++]=out1;
        }
       */
    });
  }

  var iterations = 8,
      projection = d3.geoAlbers(),
      properties = function properties(id) {
    return {};
  },
      value = function value(d) {
    return 1;
  };

  // for convenience
  carto.path = d3.geoPath().projection(null);

  carto.iterations = function (i) {
    if (arguments.length) {
      iterations = i;
      return carto;
    } else {
      return iterations;
    }
  };

  carto.value = function (v) {
    if (arguments.length) {
      value = d3.functor(v);
      return carto;
    } else {
      return value;
    }
  };

  carto.projection = function (p) {
    if (arguments.length) {
      projection = p;
      return carto;
    } else {
      return projection;
    }
  };

  carto.feature = function (topology, geom) {
    return {
      type: "Feature",
      id: geom.id,
      properties: properties.call(null, geom, topology),
      geometry: {
        type: geom.type,
        coordinates: topojson.feature(topology, geom).geometry.coordinates
      }
    };
  };

  carto.meshArcs = function (topology, o, filter) {
    var arcs = [];

    function arc(i) {
      var j = i < 0 ? ~i : i;
      (geomsByArc[j] || (geomsByArc[j] = [])).push({
        i: i,
        g: geom
      });
    }

    function line(arcs) {
      arcs.forEach(arc);
    }

    function polygon(arcs) {
      arcs.forEach(line);
    }

    function geometry(o) {
      if (o.type === "GeometryCollection") o.geometries.forEach(geometry);else if (o.type in geometryType) geom = o, geometryType[o.type](o.arcs);
    }

    if (arguments.length > 1) {
      var geomsByArc = [],
          geom;

      var geometryType = {
        LineString: line,
        MultiLineString: polygon,
        Polygon: polygon,
        MultiPolygon: function MultiPolygon(arcs) {
          arcs.forEach(polygon);
        }
      };

      geometry(o);

      geomsByArc.forEach(arguments.length < 3 ? function (geoms) {
        arcs.push(geoms[0].i);
      } : function (geoms) {
        if (filter(geoms[0].g, geoms[geoms.length - 1].g)) arcs.push(geoms[0].i);
      });
    } else {
      for (var i = 0, n = topology.arcs.length; i < n; ++i) {
        arcs.push(i);
      }
    }

    return arcs;
  };

  carto.stitchArcs = function (topology, arcs) {
    var stitchedArcs = {},
        fragmentByStart = {},
        fragmentByEnd = {},
        fragments = [],
        emptyIndex = -1;

    // Stitch empty arcs first, since they may be subsumed by other arcs.
    arcs.forEach(function (i, j) {
      var arc = topology.arcs[i < 0 ? ~i : i],
          t;
      if (arc.length < 3 && !arc[1][0] && !arc[1][1]) {
        t = arcs[++emptyIndex], arcs[emptyIndex] = i, arcs[j] = t;
      }
    });

    arcs.forEach(function (i) {
      var e = ends(i),
          start = e[0],
          end = e[1],
          f,
          g;

      if (f = fragmentByEnd[start]) {
        delete fragmentByEnd[f.end];
        f.push(i);
        f.end = end;
        if (g = fragmentByStart[end]) {
          delete fragmentByStart[g.start];
          var fg = g === f ? f : f.concat(g);
          fragmentByStart[fg.start = f.start] = fragmentByEnd[fg.end = g.end] = fg;
        } else {
          fragmentByStart[f.start] = fragmentByEnd[f.end] = f;
        }
      } else if (f = fragmentByStart[end]) {
        delete fragmentByStart[f.start];
        f.unshift(i);
        f.start = start;
        if (g = fragmentByEnd[start]) {
          delete fragmentByEnd[g.end];
          var gf = g === f ? f : g.concat(f);
          fragmentByStart[gf.start = g.start] = fragmentByEnd[gf.end = f.end] = gf;
        } else {
          fragmentByStart[f.start] = fragmentByEnd[f.end] = f;
        }
      } else {
        f = [i];
        fragmentByStart[f.start = start] = fragmentByEnd[f.end = end] = f;
      }
    });

    function ends(i) {
      var arc = topology.arcs[i < 0 ? ~i : i],
          p0 = arc[0],
          p1;
      if (topology.transform) p1 = [0, 0], arc.forEach(function (dp) {
        p1[0] += dp[0], p1[1] += dp[1];
      });else p1 = arc[arc.length - 1];
      return i < 0 ? [p1, p0] : [p0, p1];
    }

    function flush(fragmentByEnd, fragmentByStart) {
      for (var k in fragmentByEnd) {
        var f = fragmentByEnd[k];
        delete fragmentByStart[f.start];
        delete f.start;
        delete f.end;
        f.forEach(function (i) {
          stitchedArcs[i < 0 ? ~i : i] = 1;
        });
        fragments.push(f);
      }
    }

    flush(fragmentByEnd, fragmentByStart);
    flush(fragmentByStart, fragmentByEnd);
    arcs.forEach(function (i) {
      if (!stitchedArcs[i < 0 ? ~i : i]) fragments.push([i]);
    });

    return object(topology, {
      type: "MultiLineString",
      arcs: fragments
    });
  };

  carto.features = function (topo, geometries) {
    return geometries.map(function (f) {
      return carto.feature(topo, f);
    });
  };

  carto.properties = function (props) {
    if (arguments.length) {
      properties = d3.functor(props);
      return carto;
    } else {
      return properties;
    }
  };

  return carto;
};

var transformer = d3.cartogram.transformer = function (tf) {
  var kx = tf.scale[0],
      ky = tf.scale[1],
      dx = tf.translate[0],
      dy = tf.translate[1];

  function transform(c) {
    return [c[0] * kx + dx, c[1] * ky + dy];
  }

  transform.invert = function (c) {
    return [(c[0] - dx) / kx, (c[1] - dy) / ky];
  };

  return transform;
};

function angle(a, b) {
  return Math.atan2(b[1] - a[1], b[0] - a[0]);
}

function distance(a, b) {
  var dx = b[0] - a[0],
      dy = b[1] - a[1];
  return Math.sqrt(dx * dx + dy * dy);
}

function projector(proj) {
  var types = {
    Point: proj,
    LineString: function LineString(coords) {
      return coords.map(proj);
    },
    MultiLineString: function MultiLineString(arcs) {
      return arcs.map(types.LineString);
    },
    Polygon: function Polygon(rings) {
      return rings.map(types.LineString);
    },
    MultiPolygon: function MultiPolygon(rings) {
      return rings.map(types.Polygon);
    }
  };
  return function (geom) {
    return types[geom.type](geom.coordinates);
  };
}
function cosArctan(dx, dy) {
  if (dy === 0) return 0;
  var div = dx / dy;
  return dy > 0 ? 1 / Math.sqrt(1 + div * div) : -1 / Math.sqrt(1 + div * div);
}
function sinArctan(dx, dy) {
  if (dy === 0) return 1;
  var div = dx / dy;
  return dy > 0 ? div / Math.sqrt(1 + div * div) : -div / Math.sqrt(1 + div * div);
}
function copy(o) {
  return o instanceof Array ? o.map(copy) : typeof o === "string" || typeof o === "number" ? o : copyObject(o);
}

function copyObject(o) {
  var obj = {};
  for (var k in o) {
    obj[k] = copy(o[k]);
  }return obj;
}

function object(topology, o) {
  var arcs = topology.arcs ? topology.arcs : topology;
  function arc(i, points) {
    if (points.length) points.pop();
    if (!arcs[i < 0 ? ~i : i]) {
      console.log("fail");
    }
    for (var a = arcs[i < 0 ? ~i : i], k = 0, n = a.length; k < n; ++k) {
      points.push(a[k]);
    }
    if (i < 0) reverse(points, n);
  }

  function line(arcs) {
    var points = [];
    for (var i = 0, n = arcs.length; i < n; ++i) {
      arc(arcs[i], points);
    }return points;
  }

  function polygon(arcs) {
    return arcs.map(line);
  }

  function geometry(o) {
    o = Object.create(o);
    o.coordinates = geometryType[o.type](o.arcs);
    return o;
  }
  var geometryType = {
    LineString: line,
    MultiLineString: polygon,
    Polygon: polygon,
    MultiPolygon: function MultiPolygon(arcs) {
      return arcs.map(polygon);
    }
  };

  return o.type === "GeometryCollection" ? (o = Object.create(o), o.geometries = o.geometries.map(geometry), o) : geometry(o);
}

function reverse(array, n) {
  var t,
      j = array.length,
      i = j - n;while (i < --j) {
    t = array[i], array[i++] = array[j], array[j] = t;
  }
}

/***/ }),
/* 3 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = "<!--  Component -->\n<div class=\"vzb-cartogram\">\n\n    <svg class=\"vzb-cartogram-svg\">\n        <g class=\"vzb-ct-graph\">\n            <g class=\"vzb-ct-year\"></g>\n            <svg class=\"vzb-ct-map-background vzb-export\">\n                <g class=\"vzb-ct-map-graph\"></g>\n            </svg>\n            <svg class=\"vzb-ct-labels-crop\">\n                <g class=\"vzb-ct-labels\">\n                    <line class=\"vzb-ct-vertical-now\"></line>\n                </g>\n            </svg>\n\n            <g class=\"vzb-ct-axis-c-title\"><text></text></g>\n            <g class=\"vzb-ct-axis-s-title\"><text></text></g>\n            <g class=\"vzb-ct-axis-c-info\"></g>\n            <g class=\"vzb-ct-axis-s-info\"></g>\n            <g class=\"vzb-ct-tooltip vzb-hidden\">\n                <rect class=\"vzb-tooltip-border\"></rect>\n                <text class=\"vzb-tooltip-text\"></text>\n\n            </g>\n\n            <g class=\"vzb-data-warning vzb-noexport\">\n                <svg></svg>\n                <text></text>\n            </g>\n        </g>\n    </svg>\n</div>\n";

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(0);


/***/ })
/******/ ]);
//# sourceMappingURL=cartogram.js.map